using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace MyNamespace
{
	/// <summary>
	///		Configuration form for EasterCS program
	///		Developed in QuickBASIC 4.50, converted to Visual C# .Net
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation. cf. the file COPYING.txt.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>

	public class ConfigForm : Form
	{
		private System.ComponentModel.IContainer components;

		public ConfigForm()
		{
			InitializeComponent();

			// no constructor logic
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ConfigForm));
			this.buttonChangeDir = new System.Windows.Forms.Button();
			this.buttonExit = new System.Windows.Forms.Button();
			this.buttonLog = new System.Windows.Forms.Button();
			this.buttonLogFile = new System.Windows.Forms.Button();
			this.buttonSelectFile = new System.Windows.Forms.Button();
			this.folderBrowserDialogConfig = new System.Windows.Forms.FolderBrowserDialog();
			this.labelFilePath = new System.Windows.Forms.Label();
			this.labelHomeDir = new System.Windows.Forms.Label();
			this.labelLog = new System.Windows.Forms.Label();
			this.labelLogFile = new System.Windows.Forms.Label();
			this.labelLogName = new System.Windows.Forms.Label();
			this.labelSelectedFile = new System.Windows.Forms.Label();
			this.listBoxFile = new System.Windows.Forms.ListBox();
			this.openFileDialogConfig = new System.Windows.Forms.OpenFileDialog();
			this.textBoxLogFile = new System.Windows.Forms.TextBox();
			this.timerConfig = new System.Windows.Forms.Timer(this.components);
			this.labelCodeFile = new System.Windows.Forms.Label();
			this.buttonCodeFile = new System.Windows.Forms.Button();
			this.textBoxCodeFile = new System.Windows.Forms.TextBox();
			this.buttonRun = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// buttonChangeDir
			// 
			this.buttonChangeDir.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonChangeDir.Location = new System.Drawing.Point(240, 24);
			this.buttonChangeDir.Name = "buttonChangeDir";
			this.buttonChangeDir.Size = new System.Drawing.Size(64, 48);
			this.buttonChangeDir.TabIndex = 38;
			this.buttonChangeDir.Text = "Change File Path";
			this.buttonChangeDir.Click += new System.EventHandler(this.buttonChangeDir_Click);
			this.buttonChangeDir.KeyDown += new System.Windows.Forms.KeyEventHandler(this.ConfigForm_KeyDown);
			// 
			// buttonExit
			// 
			this.buttonExit.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonExit.Location = new System.Drawing.Point(429, 36);
			this.buttonExit.Name = "buttonExit";
			this.buttonExit.Size = new System.Drawing.Size(64, 24);
			this.buttonExit.TabIndex = 40;
			this.buttonExit.Text = "Exit";
			this.buttonExit.Click += new System.EventHandler(this.buttonExit_Click);
			this.buttonExit.KeyDown += new System.Windows.Forms.KeyEventHandler(this.ConfigForm_KeyDown);
			// 
			// buttonLog
			// 
			this.buttonLog.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonLog.Location = new System.Drawing.Point(264, 93);
			this.buttonLog.Name = "buttonLog";
			this.buttonLog.Size = new System.Drawing.Size(88, 21);
			this.buttonLog.TabIndex = 23;
			this.buttonLog.Text = "Is Off";
			this.buttonLog.Click += new System.EventHandler(this.buttonLog_Click);
			this.buttonLog.KeyDown += new System.Windows.Forms.KeyEventHandler(this.ConfigForm_KeyDown);
			// 
			// buttonLogFile
			// 
			this.buttonLogFile.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonLogFile.Location = new System.Drawing.Point(128, 257);
			this.buttonLogFile.Name = "buttonLogFile";
			this.buttonLogFile.Size = new System.Drawing.Size(104, 21);
			this.buttonLogFile.TabIndex = 25;
			this.buttonLogFile.Text = "Change It";
			this.buttonLogFile.Click += new System.EventHandler(this.buttonLogFile_Click);
			this.buttonLogFile.KeyDown += new System.Windows.Forms.KeyEventHandler(this.ConfigForm_KeyDown);
			// 
			// buttonSelectFile
			// 
			this.buttonSelectFile.Location = new System.Drawing.Point(338, 24);
			this.buttonSelectFile.Name = "buttonSelectFile";
			this.buttonSelectFile.Size = new System.Drawing.Size(64, 48);
			this.buttonSelectFile.TabIndex = 39;
			this.buttonSelectFile.Text = "Select a File";
			this.buttonSelectFile.Click += new System.EventHandler(this.buttonSelectFile_Click);
			this.buttonSelectFile.KeyDown += new System.Windows.Forms.KeyEventHandler(this.ConfigForm_KeyDown);
			// 
			// labelFilePath
			// 
			this.labelFilePath.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelFilePath.Location = new System.Drawing.Point(24, 168);
			this.labelFilePath.Name = "labelFilePath";
			this.labelFilePath.Size = new System.Drawing.Size(648, 16);
			this.labelFilePath.TabIndex = 110;
			this.labelFilePath.Text = "File path: C:\\MMMMMMMMMMMM\\MMMMMMMMMM\\MMMMMMMMMMM\\MMMMMMMMM\\MMMMMM\\MMMMM";
			// 
			// labelHomeDir
			// 
			this.labelHomeDir.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelHomeDir.Location = new System.Drawing.Point(32, 132);
			this.labelHomeDir.Name = "labelHomeDir";
			this.labelHomeDir.Size = new System.Drawing.Size(640, 16);
			this.labelHomeDir.TabIndex = 101;
			this.labelHomeDir.Text = "Home Dir: C:\\MMMMMMMMMMMM\\MMMMMMMMMM\\MMMMMMMMMMM\\MMMMMMMMM\\MMMMMM\\MMMMM";
			// 
			// labelLog
			// 
			this.labelLog.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelLog.Location = new System.Drawing.Point(120, 94);
			this.labelLog.Name = "labelLog";
			this.labelLog.Size = new System.Drawing.Size(144, 16);
			this.labelLog.TabIndex = 9;
			this.labelLog.Text = "Log to file mode:";
			// 
			// labelLogFile
			// 
			this.labelLogFile.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelLogFile.Location = new System.Drawing.Point(48, 240);
			this.labelLogFile.Name = "labelLogFile";
			this.labelLogFile.Size = new System.Drawing.Size(424, 16);
			this.labelLogFile.TabIndex = 13;
			this.labelLogFile.Text = "Log File: <Not set>";
			// 
			// labelLogName
			// 
			this.labelLogName.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelLogName.Location = new System.Drawing.Point(360, 95);
			this.labelLogName.Name = "labelLogName";
			this.labelLogName.Size = new System.Drawing.Size(312, 16);
			this.labelLogName.TabIndex = 17;
			this.labelLogName.Text = "Log File: NoName.log";
			// 
			// labelSelectedFile
			// 
			this.labelSelectedFile.Location = new System.Drawing.Point(120, 204);
			this.labelSelectedFile.Name = "labelSelectedFile";
			this.labelSelectedFile.Size = new System.Drawing.Size(352, 16);
			this.labelSelectedFile.TabIndex = 148;
			this.labelSelectedFile.Text = "Selected file: NoName.log";
			// 
			// listBoxFile
			// 
			this.listBoxFile.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.listBoxFile.ItemHeight = 16;
			this.listBoxFile.Location = new System.Drawing.Point(480, 192);
			this.listBoxFile.Name = "listBoxFile";
			this.listBoxFile.ScrollAlwaysVisible = true;
			this.listBoxFile.Size = new System.Drawing.Size(200, 212);
			this.listBoxFile.TabIndex = 37;
			this.listBoxFile.SelectedIndexChanged += new System.EventHandler(this.listBoxFile_SelectedIndexChanged);
			this.listBoxFile.KeyDown += new System.Windows.Forms.KeyEventHandler(this.ConfigForm_KeyDown);
			// 
			// openFileDialogConfig
			// 
			this.openFileDialogConfig.Title = "<Title ?>";
			// 
			// textBoxLogFile
			// 
			this.textBoxLogFile.Location = new System.Drawing.Point(240, 256);
			this.textBoxLogFile.Name = "textBoxLogFile";
			this.textBoxLogFile.Size = new System.Drawing.Size(232, 22);
			this.textBoxLogFile.TabIndex = 27;
			this.textBoxLogFile.TextChanged += new System.EventHandler(this.textBoxLogFile_TextChanged);
			this.textBoxLogFile.KeyDown += new System.Windows.Forms.KeyEventHandler(this.ConfigForm_KeyDown);
			// 
			// timerConfig
			// 
			this.timerConfig.Enabled = true;
			this.timerConfig.Interval = 500;
			this.timerConfig.Tick += new System.EventHandler(this.timerConfig_Tick);
			// 
			// labelCodeFile
			// 
			this.labelCodeFile.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelCodeFile.Location = new System.Drawing.Point(41, 281);
			this.labelCodeFile.Name = "labelCodeFile";
			this.labelCodeFile.Size = new System.Drawing.Size(431, 16);
			this.labelCodeFile.TabIndex = 149;
			this.labelCodeFile.Text = "Code File: <Not set>";
			// 
			// buttonCodeFile
			// 
			this.buttonCodeFile.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonCodeFile.Location = new System.Drawing.Point(128, 300);
			this.buttonCodeFile.Name = "buttonCodeFile";
			this.buttonCodeFile.Size = new System.Drawing.Size(104, 21);
			this.buttonCodeFile.TabIndex = 150;
			this.buttonCodeFile.Text = "Change It";
			this.buttonCodeFile.Click += new System.EventHandler(this.buttonCodeFile_Click);
			this.buttonCodeFile.KeyDown += new System.Windows.Forms.KeyEventHandler(this.ConfigForm_KeyDown);
			// 
			// textBoxCodeFile
			// 
			this.textBoxCodeFile.Location = new System.Drawing.Point(242, 299);
			this.textBoxCodeFile.Name = "textBoxCodeFile";
			this.textBoxCodeFile.Size = new System.Drawing.Size(232, 22);
			this.textBoxCodeFile.TabIndex = 151;
			// 
			// buttonRun
			// 
			this.buttonRun.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonRun.Location = new System.Drawing.Point(58, 300);
			this.buttonRun.Name = "buttonRun";
			this.buttonRun.Size = new System.Drawing.Size(64, 21);
			this.buttonRun.TabIndex = 152;
			this.buttonRun.Text = "Run";
			this.buttonRun.Click += new System.EventHandler(this.buttonRun_Click);
			this.buttonRun.KeyDown += new System.Windows.Forms.KeyEventHandler(this.ConfigForm_KeyDown);
			// 
			// ConfigForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(8, 15);
			this.ClientSize = new System.Drawing.Size(680, 404);
			this.Controls.Add(this.buttonRun);
			this.Controls.Add(this.textBoxCodeFile);
			this.Controls.Add(this.buttonCodeFile);
			this.Controls.Add(this.labelCodeFile);
			this.Controls.Add(this.textBoxLogFile);
			this.Controls.Add(this.labelSelectedFile);
			this.Controls.Add(this.buttonSelectFile);
			this.Controls.Add(this.buttonExit);
			this.Controls.Add(this.buttonChangeDir);
			this.Controls.Add(this.buttonLogFile);
			this.Controls.Add(this.buttonLog);
			this.Controls.Add(this.listBoxFile);
			this.Controls.Add(this.labelLogName);
			this.Controls.Add(this.labelLogFile);
			this.Controls.Add(this.labelFilePath);
			this.Controls.Add(this.labelHomeDir);
			this.Controls.Add(this.labelLog);
			this.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "ConfigForm";
			this.Text = "ConfigForm";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.ConfigForm_Closing);
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.ConfigForm_KeyDown);
			this.ResumeLayout(false);
			this.PerformLayout();

		}
		#endregion

		private Timer timerConfig;
		private Label labelLog;
		private Label labelHomeDir;
		private Label labelLogFile;
		private Label labelLogName;
		private Button buttonLogFile;
		private Button buttonChangeDir;
		private Button buttonExit;
		private TextBox textBoxLogFile;
		private Button buttonLog;
		private ListBox listBoxFile;
		private FolderBrowserDialog folderBrowserDialogConfig;
		private OpenFileDialog openFileDialogConfig;
		private Label labelSelectedFile;
		private Label labelFilePath;
		private Label labelCodeFile;
		private Button buttonCodeFile;
		private TextBox textBoxCodeFile;
		private Button buttonRun;
		private Button buttonSelectFile;

		// -------- Begin Main program, Configuration
		public void Config()
		{
			// don't allow Config form to be brought up more than once
			if (Common.configUp) { Dispose(true); return; }
			Common.configUp = true;
			this.Text = Global.title + " - Configuration";
			labelHomeDir.Text = "Home Dir: " + Common.homeDir;
			timerConfig_Tick();
			textBoxLogFile.Focus();
			GetFileNames();
		}

		private void GetFileNames() // populate the listBoxFile with file names
		{
			try
			{
				DirectoryInfo di = new DirectoryInfo(Environment.CurrentDirectory);
				listBoxFile.Items.Clear();
				string filter = "*.log";
				if (Common.selectFilter == 2) filter = "*.EaC";
				if (Common.selectFilter > 2) filter = "*.*";
				foreach (FileInfo FI in di.GetFiles(filter))
				{
					listBoxFile.Items.Add(FI.Name);
				}
			}
			catch (Exception ex)
			{
				Common.ReportError("GetFileNames:", ex.Message);
			}
		}

		private void buttonChangeDir_Click(object sender, System.EventArgs e)
		// bring up folderBrowserDialog
		{
			folderBrowserDialogConfig.SelectedPath = Environment.CurrentDirectory;
			folderBrowserDialogConfig.Description = Global.title + " - Select a file path";
			folderBrowserDialogConfig.ShowDialog();
			Directory.SetCurrentDirectory(folderBrowserDialogConfig.SelectedPath);
			Common.selectPath = Environment.CurrentDirectory;
			GetFileNames();
		}

		private void buttonExit_Click(object sender, System.EventArgs e)
		// exit Configuration form
		{
			Common.configUp = false;
			Dispose(true);
		}

		private void buttonLog_Click(object sender, System.EventArgs e)
		// toggle Logging of output screen to Log File
		{
			Common.ToggleLogg();
			DisplayLog();
			buttonLog.Focus();
		}

		private void buttonSelectFile_Click(object sender, System.EventArgs e)
		// bring up openFileDialog
		{
			string st = Environment.CurrentDirectory.ToString();
			openFileDialogConfig.Reset();	// Reset needed to be able to change InitialDirectory
			openFileDialogConfig.InitialDirectory = st;
			openFileDialogConfig.Filter = "Log files (*.log)|*.log|Code files (*.EaC)|*.eac|All files(*.*)|*.*";
			openFileDialogConfig.FilterIndex = Common.selectFilter;
			openFileDialogConfig.RestoreDirectory = false;
			openFileDialogConfig.Title = Global.title + " - Select a file";
			if(openFileDialogConfig.ShowDialog() == DialogResult.OK)
			{
				st = openFileDialogConfig.FileName.ToString();
 				int i = st.LastIndexOf(@"\");					// seperate selected path and file strings
				Common.selectPath = st.Substring(0, i);
				Common.selectFile = st.Substring(i+1);
				Directory.SetCurrentDirectory(Common.selectPath);
				labelSelectedFile.Text = "Selected file: " + Common.selectFile;
			}
			Common.selectFilter = openFileDialogConfig.FilterIndex;
			GetFileNames();
		}

		private void buttonLogFile_Click(object sender, System.EventArgs e)
		// change name of output log file
		{
			buttonLogFile_Click();
		}

		private void buttonLogFile_Click()
		// change name of output log file
		{
			Common.DoubleSpace();
			string st = textBoxLogFile.Text;
			if (st != "")
			{
				Common.FixFName(ref st, "log");
				textBoxLogFile.Text = st;
				Common.logFileNew = st;
			}
			else
			{
				if (Common.selectFile == "")
				{
					if (Common.logFileNew != "") textBoxLogFile.Text = Common.logFileNew;
				}
				else
				{
					textBoxLogFile.Text = Common.selectFile;
				}
			}
			DisplayLogFile();
			RunForm.FocusBothUs();
			textBoxLogFile.Focus();
			textBoxLogFile.SelectionStart = textBoxLogFile.Text.Length;
		}

		private void DisplayLog() // display Log to file mode: On/Off
		{
			if (Common.logg)
				buttonLog.Text = "Is On";
			else
				buttonLog.Text = "Is Off";
		}

		private void DisplayLogName() // display name of open log file
		{
			if (Common.logg)
				labelLogName.Text = "To log file: " + Common.logFile;
			else
				labelLogName.Text = "";
		}

		private void DisplayLogFile() // display name of Output Log file
		{
			string st = Common.logFileNew;
			if (st == "") st = "EasterCS.log";
			labelLogFile.Text = "Log File: " + st;
		}

		private void listBoxFile_SelectedIndexChanged(object sender, System.EventArgs e)
		// save the selected file name
		{
			int i = listBoxFile.SelectedIndex;
			Common.selectFile = listBoxFile.Items[i].ToString();
		}

		private void ConfigForm_KeyDown(object sender, KeyEventArgs e)
		// process keys when in LogFile box
		{
			if (e.KeyCode == Keys.Return) // return is an accept key here
			{
				// this sounds the bell
				if (buttonLogFile.Enabled) buttonLogFile_Click();
			}
			if (e.KeyCode == Keys.Escape) // ESC key pressed so exit ConfigForm
			{
				Common.configUp = false;
				Dispose(true);
			}
		}

		private void textBoxLogFile_TextChanged(object sender, System.EventArgs e)
		// process input of name of output log file
		{
			int n;
			string st;
			if (Common.running) return; // don't allow a change when Calc is running
			textBoxLogFile.Text = textBoxLogFile.Text.TrimStart(' '); // remove leading spaces
			st = textBoxLogFile.Text;
			n = st.Length;
			if (n == 0)
			{
				buttonLogFile.Enabled = true;
				return;
			}
			if (st[n-1] == ' ') // if space at right end of field
			{
				textBoxLogFile.Text = textBoxLogFile.Text.Trim(' ');			// remove trailing spaces
				textBoxLogFile.SelectionStart = textBoxLogFile.Text.Length;		// move to right end of input
				if (buttonLogFile.Enabled) buttonLogFile_Click();				// accept the input
			}
		}

		private void timerConfig_Tick(object sender, System.EventArgs e)
		// update display of changeable items
		{
			if (!Global.runFormUp)
			{
				Common.configUp = false;
				Dispose(true);
				return;
			}
			timerConfig_Tick();
		}

		private void timerConfig_Tick()	// update display of changeable items
		{
			DisplayLog();
			labelFilePath.Text = "File path: " + Environment.CurrentDirectory.ToString();
			labelSelectedFile.Text = "Selected file: " + Common.selectFile;
			DisplayLogFile();
			DisplayLogName();
			DisplayCodeFile();
			if (Common.running)
			{
				buttonChangeDir.Enabled = false;
				buttonLogFile.Enabled = false;
			}
			else
			{
				buttonChangeDir.Enabled = true;
				buttonLogFile.Enabled = true;
			}
		} // timerConfig_Tick

		private void ConfigForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		// exit Configuration form
		{
			Common.configUp = false;
		}

		private void buttonCodeFile_Click(object sender, EventArgs e)
		{
			buttonCodeFile_Click();
		}

		private void buttonCodeFile_Click()
		// change name of input code file
		{
			Common.DoubleSpace();
			string st = textBoxCodeFile.Text;
			if (st != "")
			{
				Common.FixFName(ref st, "EaC");
				textBoxCodeFile.Text = st;
				Common.codeFile = st;
			}
			else
			{
				if (Common.selectFile == "")
				{
					if (Common.codeFile != "") textBoxCodeFile.Text = Common.codeFile;
				}
				else
				{
					textBoxCodeFile.Text = Common.selectFile;
				}
			}
			DisplayCodeFile();
			RunForm.FocusBothUs();
			textBoxCodeFile.Focus();
			textBoxCodeFile.SelectionStart = textBoxCodeFile.Text.Length;
		}

		private void DisplayCodeFile() // display name of Input Code file
		{
			string st = Common.codeFile;
			if (st == "") st = "EasterCS.EaC";
			labelCodeFile.Text = "Code File: " + st;
		}

		private void buttonRun_Click(object sender, EventArgs e)
		{
			Common.Run();
		}
	}
}
