using System;
using System.Drawing;
using System.Windows.Forms;


namespace MyNamespace
{
	/// <summary>
	/// PlotForm is the Windows Form Component for testing the plotting functions in C#
	/// Developed by Michael Gold in 2002 and modified by Harry J. Smith in 2005
	/// See C# Corner at: http://www.c-sharpcorner.com/Code/2002/Aug/XYPlotControl.asp
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>
	public class PlotForm : Form
	{
		private Button buttonAbout;
		private Button buttonExit;
		private Button buttonPlot;
		private PlotControl PlotControlXY;
		private System.ComponentModel.IContainer components;
		private Timer timerPlot;
		private Button buttonWFreq;
		private Button buttonWFreq7600;
		private Button buttonWFreqMax;
		private Button buttonOByJFreq;
		private Button buttonOByJFreq7600;
		private Button buttonOByJFreqMax;
		public static Screen screen;

		public PlotForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.Text = Global.title + " - Plot";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(PlotForm));
			this.buttonExit = new System.Windows.Forms.Button();
			this.buttonAbout = new System.Windows.Forms.Button();
			this.buttonPlot = new System.Windows.Forms.Button();
			this.timerPlot = new System.Windows.Forms.Timer(this.components);
			this.buttonWFreq = new System.Windows.Forms.Button();
			this.buttonWFreq7600 = new System.Windows.Forms.Button();
			this.buttonWFreqMax = new System.Windows.Forms.Button();
			this.buttonOByJFreq = new System.Windows.Forms.Button();
			this.buttonOByJFreq7600 = new System.Windows.Forms.Button();
			this.buttonOByJFreqMax = new System.Windows.Forms.Button();
			this.PlotControlXY = new MyNamespace.PlotControl();
			this.SuspendLayout();
			// 
			// buttonExit
			// 
			this.buttonExit.BackColor = System.Drawing.SystemColors.Control;
			this.buttonExit.Location = new System.Drawing.Point(918, 739);
			this.buttonExit.Name = "buttonExit";
			this.buttonExit.Size = new System.Drawing.Size(48, 24);
			this.buttonExit.TabIndex = 11;
			this.buttonExit.Text = "Exit";
			this.buttonExit.UseVisualStyleBackColor = false;
			this.buttonExit.Click += new System.EventHandler(this.buttonExit_Click);
			this.buttonExit.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonExit_KeyDown);
			// 
			// buttonAbout
			// 
			this.buttonAbout.BackColor = System.Drawing.SystemColors.Control;
			this.buttonAbout.Location = new System.Drawing.Point(864, 739);
			this.buttonAbout.Name = "buttonAbout";
			this.buttonAbout.Size = new System.Drawing.Size(48, 24);
			this.buttonAbout.TabIndex = 10;
			this.buttonAbout.Text = "About";
			this.buttonAbout.UseVisualStyleBackColor = false;
			this.buttonAbout.Click += new System.EventHandler(this.buttonAbout_Click);
			this.buttonAbout.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonAbout_KeyDown);
			// 
			// buttonPlot
			// 
			this.buttonPlot.BackColor = System.Drawing.SystemColors.Control;
			this.buttonPlot.Location = new System.Drawing.Point(870, 700);
			this.buttonPlot.Name = "buttonPlot";
			this.buttonPlot.Size = new System.Drawing.Size(96, 24);
			this.buttonPlot.TabIndex = 12;
			this.buttonPlot.Text = "Plot";
			this.buttonPlot.UseVisualStyleBackColor = false;
			this.buttonPlot.Click += new System.EventHandler(this.buttonPlot_Click);
			this.buttonPlot.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonPlot_KeyDown);
			// 
			// timerPlot
			// 
			this.timerPlot.Enabled = true;
			this.timerPlot.Interval = 500;
			this.timerPlot.Tick += new System.EventHandler(this.timerPlot_Tick);
			// 
			// buttonWFreq
			// 
			this.buttonWFreq.BackColor = System.Drawing.SystemColors.Control;
			this.buttonWFreq.Location = new System.Drawing.Point(234, 700);
			this.buttonWFreq.Name = "buttonWFreq";
			this.buttonWFreq.Size = new System.Drawing.Size(96, 24);
			this.buttonWFreq.TabIndex = 23;
			this.buttonWFreq.Text = "W Frequency";
			this.buttonWFreq.UseVisualStyleBackColor = false;
			this.buttonWFreq.Click += new System.EventHandler(this.buttonWFreq_Click);
			// 
			// buttonWFreq7600
			// 
			this.buttonWFreq7600.BackColor = System.Drawing.SystemColors.Control;
			this.buttonWFreq7600.Location = new System.Drawing.Point(407, 700);
			this.buttonWFreq7600.Name = "buttonWFreq7600";
			this.buttonWFreq7600.Size = new System.Drawing.Size(120, 24);
			this.buttonWFreq7600.TabIndex = 24;
			this.buttonWFreq7600.Text = "W Frequency 7600";
			this.buttonWFreq7600.UseVisualStyleBackColor = false;
			this.buttonWFreq7600.Click += new System.EventHandler(this.buttonWFreq7600_Click);
			// 
			// buttonWFreqMax
			// 
			this.buttonWFreqMax.BackColor = System.Drawing.SystemColors.Control;
			this.buttonWFreqMax.Location = new System.Drawing.Point(589, 700);
			this.buttonWFreqMax.Name = "buttonWFreqMax";
			this.buttonWFreqMax.Size = new System.Drawing.Size(127, 24);
			this.buttonWFreqMax.TabIndex = 25;
			this.buttonWFreqMax.Text = "W Frequency 5700000";
			this.buttonWFreqMax.UseVisualStyleBackColor = false;
			this.buttonWFreqMax.Click += new System.EventHandler(this.buttonWFreqMax_Click);
			// 
			// buttonOByJFreq
			// 
			this.buttonOByJFreq.BackColor = System.Drawing.SystemColors.Control;
			this.buttonOByJFreq.Location = new System.Drawing.Point(234, 739);
			this.buttonOByJFreq.Name = "buttonOByJFreq";
			this.buttonOByJFreq.Size = new System.Drawing.Size(96, 24);
			this.buttonOByJFreq.TabIndex = 26;
			this.buttonOByJFreq.Text = "O By J Freq";
			this.buttonOByJFreq.UseVisualStyleBackColor = false;
			this.buttonOByJFreq.Click += new System.EventHandler(this.buttonOByJFreq_Click);
			// 
			// buttonOByJFreq7600
			// 
			this.buttonOByJFreq7600.BackColor = System.Drawing.SystemColors.Control;
			this.buttonOByJFreq7600.Location = new System.Drawing.Point(407, 739);
			this.buttonOByJFreq7600.Name = "buttonOByJFreq7600";
			this.buttonOByJFreq7600.Size = new System.Drawing.Size(120, 24);
			this.buttonOByJFreq7600.TabIndex = 27;
			this.buttonOByJFreq7600.Text = "O By J Freq 7600";
			this.buttonOByJFreq7600.UseVisualStyleBackColor = false;
			this.buttonOByJFreq7600.Click += new System.EventHandler(this.buttonOByJFreq7600_Click);
			// 
			// buttonOByJFreqMax
			// 
			this.buttonOByJFreqMax.BackColor = System.Drawing.SystemColors.Control;
			this.buttonOByJFreqMax.Location = new System.Drawing.Point(589, 739);
			this.buttonOByJFreqMax.Name = "buttonOByJFreqMax";
			this.buttonOByJFreqMax.Size = new System.Drawing.Size(127, 24);
			this.buttonOByJFreqMax.TabIndex = 28;
			this.buttonOByJFreqMax.Text = "O By J Freq 5700000";
			this.buttonOByJFreqMax.UseVisualStyleBackColor = false;
			this.buttonOByJFreqMax.Click += new System.EventHandler(this.buttonOByJFreqMax_Click);
			// 
			// PlotControlXY
			// 
			this.PlotControlXY.AbsolutePoint = new System.Drawing.Point(-2147483608, -2147483024);
			this.PlotControlXY.BackColor = System.Drawing.SystemColors.Window;
			this.PlotControlXY.ConnectPointsFlag = false;
			this.PlotControlXY.CurrentIndex = 0;
			this.PlotControlXY.LabelX = "";
			this.PlotControlXY.LabelY = "";
			this.PlotControlXY.LineColor = System.Drawing.Color.Blue;
			this.PlotControlXY.Location = new System.Drawing.Point(12, 35);
			this.PlotControlXY.Name = "PlotControlXY";
			this.PlotControlXY.NumberOfPoints = 0;
			this.PlotControlXY.Size = new System.Drawing.Size(968, 659);
			this.PlotControlXY.TabIndex = 22;
			this.PlotControlXY.XOrigin = 0F;
			this.PlotControlXY.XTickValue = 1F;
			this.PlotControlXY.XValue = -2.147484E+09F;
			this.PlotControlXY.YOrigin = 0F;
			this.PlotControlXY.YTickValue = 1F;
			this.PlotControlXY.YValue = -2.147484E+09F;
			this.PlotControlXY.KeyDown += new System.Windows.Forms.KeyEventHandler(this.PlotControlXY_KeyDown);
			// 
			// PlotForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Window;
			this.ClientSize = new System.Drawing.Size(992, 775);
			this.Controls.Add(this.buttonOByJFreqMax);
			this.Controls.Add(this.buttonOByJFreq7600);
			this.Controls.Add(this.buttonOByJFreq);
			this.Controls.Add(this.buttonWFreqMax);
			this.Controls.Add(this.buttonWFreq7600);
			this.Controls.Add(this.buttonWFreq);
			this.Controls.Add(this.buttonPlot);
			this.Controls.Add(this.buttonAbout);
			this.Controls.Add(this.buttonExit);
			this.Controls.Add(this.PlotControlXY);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "PlotForm";
			this.Text = "<App.Title> - Run";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.PlotForm_Closing);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		// -------- Begin Main program, Plot
		public void Plot() 
		{
			// don't allow Plot form to be brought up more than once
			if (Common.plotUp) { Dispose(true); return; }
			Common.plotUp = true;
			screen = Screen.PrimaryScreen;
			// gets the screen size but not used
			Size size = new System.Drawing.Size(screen.Bounds.Width, screen.Bounds.Height);
			if (EasterCS.label == "")
				EasterCS.WFreq();
			PlotIt();
			buttonExit.Focus();	// a new plot form just came up
		}

		private void buttonExit_Click(object sender, System.EventArgs e)
		// exit Plot Form
		{
			Common.plotUp = false;
			Common.abortCalc = true;
			Dispose(true);
		}

		private void buttonAbout_Click(object sender, System.EventArgs e)
			// bring up information about this program
		{
			try
			{
				AboutForm aboutForm = new AboutForm();
				aboutForm.ShowDialog();
				if (aboutForm.DialogResult == DialogResult.Cancel)
				{
					aboutForm.Dispose();
				}
			}
			catch (Exception ex)
			{
				System.Console.WriteLine(ex.Message.ToString());
			}
		}

		private void buttonPlot_Click(object sender, System.EventArgs e)
		{
			PlotIt();
		}

		private void PlotIt()
		{
			if (EasterCS.label == "")
				return;
			float x;
			float y;
			float maxY = 0;
			int day;                            // Day tabulating
			if (Common.running) return;
			for (day = 21, x = 0; day <= 31; day++, x++)
			{
				y = (float)EasterCS.tA3[day];
				if (y > maxY)
					maxY = y;
			}
			for (day = 1; day <= 26; day++, x++)
			{
				y = (float)EasterCS.tA4[day];
				if (y > maxY)
					maxY = y;
			}
			float maxPlot = maxY;
			if (maxPlot <= 10)
				maxPlot = 5 * (float)Math.Ceiling(maxPlot / 5);
			else if (maxPlot <= 100)
				maxPlot = 25 * (float)Math.Ceiling(maxPlot / 25);
			else if (maxPlot <= 1000)
				maxPlot = 50 * (float)Math.Ceiling(maxPlot / 50);
			else if (maxPlot <= 10000)
				maxPlot = 500 * (float)Math.Ceiling(maxPlot / 500);
			else if (maxPlot <= 100000)
				maxPlot = 5000 * (float)Math.Ceiling(maxPlot / 5000);
			else
				maxPlot = 50000 * (float)Math.Ceiling(maxPlot / 50000);
			float yTick = maxPlot / 25;
			PlotControlXY.Reset();
			PlotControlXY.NumberOfPens = 1;
			PlotControlXY.AddPen(0, Color.Green, 2f);
			PlotControlXY.XTickValue = 1;
			PlotControlXY.YTickValue = yTick;
			PlotControlXY.XOrigin = 0;
			PlotControlXY.YOrigin = 0;
			PlotControlXY.LabelX = "Day Number -- 1 = 3/22, 35 = 4/25 -- " + EasterCS.label +
				" -- y Tick mark = " + yTick + " -- Max y = " + maxY;
			PlotControlXY.LabelY = "    Frequency --          Number of times Easter         falls on this date";
			float dx = 0.1f;
			float dy = 500 * maxY / 214287f;
			for (day = 21, x = 0; day <= 31; day++, x++)
			{
				y = (float)EasterCS.tA3[day];
				PlotControlXY.AddPoint(x, y);
				PlotControlXY.AddPoint(x + dx, y - dy);
				PlotControlXY.AddPoint(x + dx, y + dy);
				PlotControlXY.AddPoint(x - dx, y + dy);
				PlotControlXY.AddPoint(x - dx, y - dy);
				PlotControlXY.AddPoint(x, y);
			}
			for (day = 1; day <= 26; day++, x++)
			{
				y = (float)EasterCS.tA4[day];
				PlotControlXY.AddPoint(x, y);
				PlotControlXY.AddPoint(x + dx, y - dy);
				PlotControlXY.AddPoint(x + dx, y + dy);
				PlotControlXY.AddPoint(x - dx, y + dy);
				PlotControlXY.AddPoint(x - dx, y - dy);
				PlotControlXY.AddPoint(x, y);
			}
			PlotControlXY.m_bConnectPoints = true;
			PlotControlXY.Invalidate();
			Global.objRunForm.SetNotRunning();
		} // PlotIt

		private void timerPlot_Tick(object sender, System.EventArgs e)
		// update display of changeable items
		{
			if (!Global.runFormUp)
			{
				Common.plotUp = false;
				Dispose(true);
				return;
			}
		}

		private void buttonExit_KeyDown(object sender, KeyEventArgs e)
		{
			TestExit(e);
		}

		private void TestExit(KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Escape)
			{
				Common.plotUp = false;
				Dispose(true);
			}
		}

		private void buttonAbout_KeyDown(object sender, KeyEventArgs e)
		{
			TestExit(e);
		}

		private void buttonPlot_KeyDown(object sender, KeyEventArgs e)
		{
			TestExit(e);
		}

		private void PlotControlXY_KeyDown(object sender, KeyEventArgs e)
		{
			TestExit(e);
		}

		private void PlotForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		// exit Plot form
		{
			Common.plotUp = false;
			Common.abortCalc = true;
		}

		private void buttonWFreq_Click(object sender, EventArgs e)
		{
			WFreq();
		}

		private void WFreq()
		{
			EasterCS.WFreq();
			PlotIt();
			buttonExit.Focus();
		}

		private void buttonWFreq7600_Click(object sender, EventArgs e)
		{
			EasterCS.startYear = 1900;
			EasterCS.endYear = 9499;
			Global.objRunForm.Reset();
			EasterCS.WFreq();
			PlotIt();
			buttonExit.Focus();
		}

		private void buttonWFreqMax_Click(object sender, EventArgs e)
		{
			EasterCS.startYear = 1900;
			EasterCS.endYear = 5701899;
			Global.objRunForm.Reset();
			EasterCS.WFreq();
			PlotIt();
			buttonExit.Focus();
		}

		private void buttonOByJFreq_Click(object sender, EventArgs e)
		{
			EasterCS.OByJFreq();
			PlotIt();
			buttonExit.Focus();
		}

		private void buttonOByJFreq7600_Click(object sender, EventArgs e)
		{
			EasterCS.startYear = 1900;
			EasterCS.endYear = 9499;
			Global.objRunForm.Reset();
			EasterCS.OByJFreq();
			PlotIt();
			buttonExit.Focus();
		}

		private void buttonOByJFreqMax_Click(object sender, EventArgs e)
		{
			EasterCS.startYear = 1900;
			EasterCS.endYear = 5701899;
			Global.objRunForm.Reset();
			EasterCS.OByJFreq();
			PlotIt();
			buttonExit.Focus();
		}
	}
}

