using System;
using System.IO;
using System.Windows.Forms; // for Application

namespace MyNamespace
{
	/// <summary>
	///		Run form for EasterCS program
	///		Developed in QuickBASIC 4.50, converted to Visual C# .Net
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation. cf. the file COPYING.txt.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>

	public class RunForm : Form
	{
		private Button buttonAbortCalc;
		private Button buttonClearLogFile;
		private Button buttonClearOutput;
		private Button buttonConfiguration;
		private Button buttonLog;
		private Button buttonQuit;
		private Label labelCtrlF9;
		private Label labelEsc;
		private Label labelF11;
		private Label labelF12;
		private Label labelF2;
		private Label labelF6;
		private Label labelF9;
		private Label labelRunning;
		private MainMenu mainMenuRun;
		private MenuItem menuItemAbout;
		private MenuItem menuItemExit;
		private MenuItem menuItemFile;
		private MenuItem menuItemHelp;
		private MenuItem menuItemHelpForm;
		private RichTextBox richTextOut;
		private System.ComponentModel.IContainer components;
		private Timer timerRun;
		private Button buttonYearPlus;
		private Button buttonYearMinus;
		private Button buttonWOByYear;
		private Button buttonWByDate;
		private Button buttonWFreq;
		private Button buttonOByGDate;
		private Button buttonOByJDate;
		private Button buttonOByJFreq;
		private Button buttonOByGFreq;
		private TextBox textBoxYear;
		private TextBox textBoxStartYear;
		private TextBox textBoxEndYear;
		private Label labelYear;
		private Label labelStartYear;
		private Label labelEndTear;
		private Button buttonReset;
		private Label labelF8;
		private Label labelF7;
		private Label labelCtrlF7;
		private Label labelF3;
		private Label labelF4;
		private Label labelF5;
		private Label labelCtrlF5;
		private Label labelCtrlF;
		private Label labelCtrlM;
		private Label labelCtrlP;
		public Button buttonPlot;

		public RunForm()
		{
			InitializeComponent();

			Global.runTextOut = richTextOut;
			Global.runTextOut.Clear();
			Global.objRunForm = this;
			this.Width = runWidth;				// Resize the form
			this.Height = runHeight - 20;
			this.CenterToScreen();
			Common.timeIt = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			runWidth = this.Width;
			runHeight = this.Height;
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(RunForm));
			this.buttonAbortCalc = new System.Windows.Forms.Button();
			this.buttonClearLogFile = new System.Windows.Forms.Button();
			this.buttonClearOutput = new System.Windows.Forms.Button();
			this.buttonConfiguration = new System.Windows.Forms.Button();
			this.buttonLog = new System.Windows.Forms.Button();
			this.buttonPlot = new System.Windows.Forms.Button();
			this.buttonQuit = new System.Windows.Forms.Button();
			this.labelCtrlF9 = new System.Windows.Forms.Label();
			this.labelEsc = new System.Windows.Forms.Label();
			this.labelF11 = new System.Windows.Forms.Label();
			this.labelF12 = new System.Windows.Forms.Label();
			this.labelF2 = new System.Windows.Forms.Label();
			this.labelF9 = new System.Windows.Forms.Label();
			this.labelRunning = new System.Windows.Forms.Label();
			this.mainMenuRun = new System.Windows.Forms.MainMenu(this.components);
			this.menuItemFile = new System.Windows.Forms.MenuItem();
			this.menuItemExit = new System.Windows.Forms.MenuItem();
			this.menuItemHelp = new System.Windows.Forms.MenuItem();
			this.menuItemHelpForm = new System.Windows.Forms.MenuItem();
			this.menuItemAbout = new System.Windows.Forms.MenuItem();
			this.richTextOut = new System.Windows.Forms.RichTextBox();
			this.timerRun = new System.Windows.Forms.Timer(this.components);
			this.labelF6 = new System.Windows.Forms.Label();
			this.buttonYearPlus = new System.Windows.Forms.Button();
			this.buttonYearMinus = new System.Windows.Forms.Button();
			this.buttonWOByYear = new System.Windows.Forms.Button();
			this.buttonWByDate = new System.Windows.Forms.Button();
			this.buttonWFreq = new System.Windows.Forms.Button();
			this.buttonOByGDate = new System.Windows.Forms.Button();
			this.buttonOByJDate = new System.Windows.Forms.Button();
			this.buttonOByJFreq = new System.Windows.Forms.Button();
			this.buttonOByGFreq = new System.Windows.Forms.Button();
			this.textBoxYear = new System.Windows.Forms.TextBox();
			this.textBoxStartYear = new System.Windows.Forms.TextBox();
			this.textBoxEndYear = new System.Windows.Forms.TextBox();
			this.labelYear = new System.Windows.Forms.Label();
			this.labelStartYear = new System.Windows.Forms.Label();
			this.labelEndTear = new System.Windows.Forms.Label();
			this.buttonReset = new System.Windows.Forms.Button();
			this.labelF8 = new System.Windows.Forms.Label();
			this.labelF7 = new System.Windows.Forms.Label();
			this.labelCtrlF7 = new System.Windows.Forms.Label();
			this.labelF3 = new System.Windows.Forms.Label();
			this.labelF4 = new System.Windows.Forms.Label();
			this.labelF5 = new System.Windows.Forms.Label();
			this.labelCtrlF5 = new System.Windows.Forms.Label();
			this.labelCtrlF = new System.Windows.Forms.Label();
			this.labelCtrlM = new System.Windows.Forms.Label();
			this.labelCtrlP = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// buttonAbortCalc
			// 
			this.buttonAbortCalc.Font = new System.Drawing.Font("Tahoma", 8F, System.Drawing.FontStyle.Bold);
			this.buttonAbortCalc.Location = new System.Drawing.Point(16, 48);
			this.buttonAbortCalc.Name = "buttonAbortCalc";
			this.buttonAbortCalc.Size = new System.Drawing.Size(88, 23);
			this.buttonAbortCalc.TabIndex = 5;
			this.buttonAbortCalc.Text = "Abort Calc.";
			this.buttonAbortCalc.Click += new System.EventHandler(this.buttonAbortCalc_Click);
			this.buttonAbortCalc.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// buttonClearLogFile
			// 
			this.buttonClearLogFile.Font = new System.Drawing.Font("Tahoma", 8F, System.Drawing.FontStyle.Bold);
			this.buttonClearLogFile.Location = new System.Drawing.Point(16, 9);
			this.buttonClearLogFile.Name = "buttonClearLogFile";
			this.buttonClearLogFile.Size = new System.Drawing.Size(88, 23);
			this.buttonClearLogFile.TabIndex = 1;
			this.buttonClearLogFile.Text = "Clear Log File";
			this.buttonClearLogFile.Click += new System.EventHandler(this.buttonClearLogFile_Click);
			this.buttonClearLogFile.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// buttonClearOutput
			// 
			this.buttonClearOutput.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonClearOutput.Location = new System.Drawing.Point(120, 48);
			this.buttonClearOutput.Name = "buttonClearOutput";
			this.buttonClearOutput.Size = new System.Drawing.Size(88, 23);
			this.buttonClearOutput.TabIndex = 4;
			this.buttonClearOutput.Text = "Clear Output";
			this.buttonClearOutput.Click += new System.EventHandler(this.buttonClearOutput_Click);
			this.buttonClearOutput.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// buttonConfiguration
			// 
			this.buttonConfiguration.Font = new System.Drawing.Font("Tahoma", 8F, System.Drawing.FontStyle.Bold);
			this.buttonConfiguration.Location = new System.Drawing.Point(224, 48);
			this.buttonConfiguration.Name = "buttonConfiguration";
			this.buttonConfiguration.Size = new System.Drawing.Size(88, 23);
			this.buttonConfiguration.TabIndex = 6;
			this.buttonConfiguration.Text = "Configuration";
			this.buttonConfiguration.Click += new System.EventHandler(this.buttonConfiguration_Click);
			this.buttonConfiguration.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// buttonLog
			// 
			this.buttonLog.Cursor = System.Windows.Forms.Cursors.Arrow;
			this.buttonLog.Font = new System.Drawing.Font("Tahoma", 7.75F, System.Drawing.FontStyle.Bold);
			this.buttonLog.Location = new System.Drawing.Point(120, 9);
			this.buttonLog.Name = "buttonLog";
			this.buttonLog.Size = new System.Drawing.Size(88, 23);
			this.buttonLog.TabIndex = 2;
			this.buttonLog.Text = "Logging Is Off";
			this.buttonLog.Click += new System.EventHandler(this.buttonLog_Click);
			this.buttonLog.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// buttonPlot
			// 
			this.buttonPlot.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonPlot.Location = new System.Drawing.Point(538, 91);
			this.buttonPlot.Name = "buttonPlot";
			this.buttonPlot.Size = new System.Drawing.Size(48, 23);
			this.buttonPlot.TabIndex = 9;
			this.buttonPlot.Text = "Plot";
			this.buttonPlot.Click += new System.EventHandler(this.buttonPlot_Click);
			this.buttonPlot.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// buttonQuit
			// 
			this.buttonQuit.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonQuit.Location = new System.Drawing.Point(604, 91);
			this.buttonQuit.Name = "buttonQuit";
			this.buttonQuit.Size = new System.Drawing.Size(48, 23);
			this.buttonQuit.TabIndex = 10;
			this.buttonQuit.Text = "Quit";
			this.buttonQuit.Click += new System.EventHandler(this.buttonQuit_Click);
			this.buttonQuit.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// labelCtrlF9
			// 
			this.labelCtrlF9.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelCtrlF9.Location = new System.Drawing.Point(40, 32);
			this.labelCtrlF9.Name = "labelCtrlF9";
			this.labelCtrlF9.Size = new System.Drawing.Size(40, 16);
			this.labelCtrlF9.TabIndex = 26;
			this.labelCtrlF9.Text = "Ctrl+F9";
			// 
			// labelEsc
			// 
			this.labelEsc.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelEsc.Location = new System.Drawing.Point(48, 72);
			this.labelEsc.Name = "labelEsc";
			this.labelEsc.Size = new System.Drawing.Size(24, 16);
			this.labelEsc.TabIndex = 34;
			this.labelEsc.Text = "Esc";
			// 
			// labelF11
			// 
			this.labelF11.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF11.Location = new System.Drawing.Point(151, 72);
			this.labelF11.Name = "labelF11";
			this.labelF11.Size = new System.Drawing.Size(29, 16);
			this.labelF11.TabIndex = 25;
			this.labelF11.Text = "F11";
			// 
			// labelF12
			// 
			this.labelF12.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF12.Location = new System.Drawing.Point(545, 116);
			this.labelF12.Name = "labelF12";
			this.labelF12.Size = new System.Drawing.Size(32, 16);
			this.labelF12.TabIndex = 30;
			this.labelF12.Text = "F12";
			// 
			// labelF2
			// 
			this.labelF2.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF2.Location = new System.Drawing.Point(615, 116);
			this.labelF2.Name = "labelF2";
			this.labelF2.Size = new System.Drawing.Size(24, 16);
			this.labelF2.TabIndex = 28;
			this.labelF2.Text = "F2";
			// 
			// labelF9
			// 
			this.labelF9.Font = new System.Drawing.Font("Tahoma", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF9.Location = new System.Drawing.Point(152, 32);
			this.labelF9.Name = "labelF9";
			this.labelF9.Size = new System.Drawing.Size(24, 16);
			this.labelF9.TabIndex = 17;
			this.labelF9.Text = "F9";
			// 
			// labelRunning
			// 
			this.labelRunning.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelRunning.Location = new System.Drawing.Point(222, 11);
			this.labelRunning.Name = "labelRunning";
			this.labelRunning.Size = new System.Drawing.Size(93, 16);
			this.labelRunning.TabIndex = 37;
			this.labelRunning.Text = "**Running**";
			// 
			// mainMenuRun
			// 
			this.mainMenuRun.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemFile,
            this.menuItemHelp});
			// 
			// menuItemFile
			// 
			this.menuItemFile.Index = 0;
			this.menuItemFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemExit});
			this.menuItemFile.Text = " &File ";
			// 
			// menuItemExit
			// 
			this.menuItemExit.Index = 0;
			this.menuItemExit.Text = "E&xit";
			this.menuItemExit.Click += new System.EventHandler(this.menuItemExit_Click);
			// 
			// menuItemHelp
			// 
			this.menuItemHelp.Index = 1;
			this.menuItemHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemHelpForm,
            this.menuItemAbout});
			this.menuItemHelp.Text = " &Help F1 ";
			// 
			// menuItemHelpForm
			// 
			this.menuItemHelpForm.Index = 0;
			this.menuItemHelpForm.Text = "&Help Form        F1";
			this.menuItemHelpForm.Click += new System.EventHandler(this.menuItemHelpForm_Click);
			// 
			// menuItemAbout
			// 
			this.menuItemAbout.Index = 1;
			this.menuItemAbout.Text = "&About...";
			this.menuItemAbout.Click += new System.EventHandler(this.menuItemAbout_Click);
			// 
			// richTextOut
			// 
			this.richTextOut.Cursor = System.Windows.Forms.Cursors.Arrow;
			this.richTextOut.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.richTextOut.Location = new System.Drawing.Point(0, 136);
			this.richTextOut.Name = "richTextOut";
			this.richTextOut.ReadOnly = true;
			this.richTextOut.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.ForcedVertical;
			this.richTextOut.Size = new System.Drawing.Size(667, 429);
			this.richTextOut.TabIndex = 13;
			this.richTextOut.Text = "";
			this.richTextOut.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// timerRun
			// 
			this.timerRun.Enabled = true;
			this.timerRun.Interval = 1000;
			this.timerRun.Tick += new System.EventHandler(this.timerRun_Tick);
			// 
			// labelF6
			// 
			this.labelF6.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF6.Location = new System.Drawing.Point(256, 72);
			this.labelF6.Name = "labelF6";
			this.labelF6.Size = new System.Drawing.Size(24, 16);
			this.labelF6.TabIndex = 20;
			this.labelF6.Text = "F6";
			// 
			// buttonYearPlus
			// 
			this.buttonYearPlus.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonYearPlus.Location = new System.Drawing.Point(592, 48);
			this.buttonYearPlus.Name = "buttonYearPlus";
			this.buttonYearPlus.Size = new System.Drawing.Size(60, 23);
			this.buttonYearPlus.TabIndex = 40;
			this.buttonYearPlus.Text = "Year+1";
			this.buttonYearPlus.Click += new System.EventHandler(this.buttonYearPlus_Click);
			this.buttonYearPlus.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// buttonYearMinus
			// 
			this.buttonYearMinus.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonYearMinus.Location = new System.Drawing.Point(526, 48);
			this.buttonYearMinus.Name = "buttonYearMinus";
			this.buttonYearMinus.Size = new System.Drawing.Size(60, 23);
			this.buttonYearMinus.TabIndex = 41;
			this.buttonYearMinus.Text = "Year-1";
			this.buttonYearMinus.Click += new System.EventHandler(this.buttonYearMinus_Click);
			this.buttonYearMinus.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// buttonWOByYear
			// 
			this.buttonWOByYear.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonWOByYear.Location = new System.Drawing.Point(16, 91);
			this.buttonWOByYear.Name = "buttonWOByYear";
			this.buttonWOByYear.Size = new System.Drawing.Size(88, 23);
			this.buttonWOByYear.TabIndex = 42;
			this.buttonWOByYear.Text = "W O By Year";
			this.buttonWOByYear.Click += new System.EventHandler(this.buttonWOByYear_Click);
			this.buttonWOByYear.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// buttonWByDate
			// 
			this.buttonWByDate.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonWByDate.Location = new System.Drawing.Point(120, 91);
			this.buttonWByDate.Name = "buttonWByDate";
			this.buttonWByDate.Size = new System.Drawing.Size(88, 23);
			this.buttonWByDate.TabIndex = 43;
			this.buttonWByDate.Text = "W By Date";
			this.buttonWByDate.Click += new System.EventHandler(this.buttonWByDate_Click);
			this.buttonWByDate.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// buttonWFreq
			// 
			this.buttonWFreq.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonWFreq.Location = new System.Drawing.Point(224, 91);
			this.buttonWFreq.Name = "buttonWFreq";
			this.buttonWFreq.Size = new System.Drawing.Size(88, 23);
			this.buttonWFreq.TabIndex = 44;
			this.buttonWFreq.Text = "W Frequency";
			this.buttonWFreq.Click += new System.EventHandler(this.buttonWFreq_Click);
			this.buttonWFreq.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// buttonOByGDate
			// 
			this.buttonOByGDate.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonOByGDate.Location = new System.Drawing.Point(327, 91);
			this.buttonOByGDate.Name = "buttonOByGDate";
			this.buttonOByGDate.Size = new System.Drawing.Size(88, 23);
			this.buttonOByGDate.TabIndex = 45;
			this.buttonOByGDate.Text = "O By G Date";
			this.buttonOByGDate.Click += new System.EventHandler(this.buttonOByGDate_Click);
			this.buttonOByGDate.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// buttonOByJDate
			// 
			this.buttonOByJDate.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonOByJDate.Location = new System.Drawing.Point(432, 91);
			this.buttonOByJDate.Name = "buttonOByJDate";
			this.buttonOByJDate.Size = new System.Drawing.Size(88, 23);
			this.buttonOByJDate.TabIndex = 46;
			this.buttonOByJDate.Text = "O By J Date";
			this.buttonOByJDate.Click += new System.EventHandler(this.buttonOByJDate_Click);
			this.buttonOByJDate.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// buttonOByJFreq
			// 
			this.buttonOByJFreq.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonOByJFreq.Location = new System.Drawing.Point(432, 48);
			this.buttonOByJFreq.Name = "buttonOByJFreq";
			this.buttonOByJFreq.Size = new System.Drawing.Size(88, 23);
			this.buttonOByJFreq.TabIndex = 47;
			this.buttonOByJFreq.Text = "O By J Freq";
			this.buttonOByJFreq.Click += new System.EventHandler(this.buttonOByJFreq_Click);
			this.buttonOByJFreq.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// buttonOByGFreq
			// 
			this.buttonOByGFreq.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonOByGFreq.Location = new System.Drawing.Point(327, 48);
			this.buttonOByGFreq.Name = "buttonOByGFreq";
			this.buttonOByGFreq.Size = new System.Drawing.Size(88, 23);
			this.buttonOByGFreq.TabIndex = 48;
			this.buttonOByGFreq.Text = "O By G Freq";
			this.buttonOByGFreq.Click += new System.EventHandler(this.buttonOByGFreq_Click);
			this.buttonOByGFreq.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// textBoxYear
			// 
			this.textBoxYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.textBoxYear.Location = new System.Drawing.Point(327, 11);
			this.textBoxYear.Name = "textBoxYear";
			this.textBoxYear.Size = new System.Drawing.Size(72, 20);
			this.textBoxYear.TabIndex = 49;
			this.textBoxYear.Text = "10000000";
			this.textBoxYear.TextChanged += new System.EventHandler(this.textBoxYear_TextChanged);
			this.textBoxYear.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// textBoxStartYear
			// 
			this.textBoxStartYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.textBoxStartYear.Location = new System.Drawing.Point(432, 12);
			this.textBoxStartYear.Name = "textBoxStartYear";
			this.textBoxStartYear.Size = new System.Drawing.Size(72, 20);
			this.textBoxStartYear.TabIndex = 50;
			this.textBoxStartYear.Text = "10000000";
			this.textBoxStartYear.TextChanged += new System.EventHandler(this.textBoxStartYear_TextChanged);
			this.textBoxStartYear.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// textBoxEndYear
			// 
			this.textBoxEndYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.textBoxEndYear.Location = new System.Drawing.Point(526, 12);
			this.textBoxEndYear.Name = "textBoxEndYear";
			this.textBoxEndYear.Size = new System.Drawing.Size(72, 20);
			this.textBoxEndYear.TabIndex = 51;
			this.textBoxEndYear.Text = "10000000";
			this.textBoxEndYear.TextChanged += new System.EventHandler(this.textBoxEndYear_TextChanged);
			this.textBoxEndYear.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// labelYear
			// 
			this.labelYear.Location = new System.Drawing.Point(346, 31);
			this.labelYear.Name = "labelYear";
			this.labelYear.Size = new System.Drawing.Size(53, 16);
			this.labelYear.TabIndex = 52;
			this.labelYear.Text = "Year";
			// 
			// labelStartYear
			// 
			this.labelStartYear.Location = new System.Drawing.Point(440, 31);
			this.labelStartYear.Name = "labelStartYear";
			this.labelStartYear.Size = new System.Drawing.Size(55, 16);
			this.labelStartYear.TabIndex = 53;
			this.labelStartYear.Text = "Start Year";
			// 
			// labelEndTear
			// 
			this.labelEndTear.Location = new System.Drawing.Point(535, 31);
			this.labelEndTear.Name = "labelEndTear";
			this.labelEndTear.Size = new System.Drawing.Size(55, 16);
			this.labelEndTear.TabIndex = 54;
			this.labelEndTear.Text = "End Year";
			// 
			// buttonReset
			// 
			this.buttonReset.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonReset.Location = new System.Drawing.Point(604, 8);
			this.buttonReset.Name = "buttonReset";
			this.buttonReset.Size = new System.Drawing.Size(48, 23);
			this.buttonReset.TabIndex = 55;
			this.buttonReset.Text = "Reset";
			this.buttonReset.Click += new System.EventHandler(this.buttonReset_Click);
			this.buttonReset.KeyDown += new System.Windows.Forms.KeyEventHandler(this.FunctionKeys);
			// 
			// labelF8
			// 
			this.labelF8.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF8.Location = new System.Drawing.Point(615, 32);
			this.labelF8.Name = "labelF8";
			this.labelF8.Size = new System.Drawing.Size(31, 16);
			this.labelF8.TabIndex = 56;
			this.labelF8.Text = "F8";
			// 
			// labelF7
			// 
			this.labelF7.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF7.Location = new System.Drawing.Point(358, 72);
			this.labelF7.Name = "labelF7";
			this.labelF7.Size = new System.Drawing.Size(24, 16);
			this.labelF7.TabIndex = 57;
			this.labelF7.Text = "F7";
			// 
			// labelCtrlF7
			// 
			this.labelCtrlF7.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelCtrlF7.Location = new System.Drawing.Point(454, 74);
			this.labelCtrlF7.Name = "labelCtrlF7";
			this.labelCtrlF7.Size = new System.Drawing.Size(41, 16);
			this.labelCtrlF7.TabIndex = 58;
			this.labelCtrlF7.Text = "Ctrl+F7";
			// 
			// labelF3
			// 
			this.labelF3.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF3.Location = new System.Drawing.Point(48, 116);
			this.labelF3.Name = "labelF3";
			this.labelF3.Size = new System.Drawing.Size(24, 16);
			this.labelF3.TabIndex = 59;
			this.labelF3.Text = "F3";
			// 
			// labelF4
			// 
			this.labelF4.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF4.Location = new System.Drawing.Point(151, 116);
			this.labelF4.Name = "labelF4";
			this.labelF4.Size = new System.Drawing.Size(24, 16);
			this.labelF4.TabIndex = 60;
			this.labelF4.Text = "F4";
			// 
			// labelF5
			// 
			this.labelF5.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelF5.Location = new System.Drawing.Point(358, 116);
			this.labelF5.Name = "labelF5";
			this.labelF5.Size = new System.Drawing.Size(24, 16);
			this.labelF5.TabIndex = 61;
			this.labelF5.Text = "F5";
			// 
			// labelCtrlF5
			// 
			this.labelCtrlF5.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelCtrlF5.Location = new System.Drawing.Point(454, 116);
			this.labelCtrlF5.Name = "labelCtrlF5";
			this.labelCtrlF5.Size = new System.Drawing.Size(41, 16);
			this.labelCtrlF5.TabIndex = 62;
			this.labelCtrlF5.Text = "Ctrl+F5";
			// 
			// labelCtrlF
			// 
			this.labelCtrlF.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelCtrlF.Location = new System.Drawing.Point(256, 116);
			this.labelCtrlF.Name = "labelCtrlF";
			this.labelCtrlF.Size = new System.Drawing.Size(40, 16);
			this.labelCtrlF.TabIndex = 63;
			this.labelCtrlF.Text = "Ctrl+F";
			// 
			// labelCtrlM
			// 
			this.labelCtrlM.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelCtrlM.Location = new System.Drawing.Point(537, 74);
			this.labelCtrlM.Name = "labelCtrlM";
			this.labelCtrlM.Size = new System.Drawing.Size(40, 16);
			this.labelCtrlM.TabIndex = 64;
			this.labelCtrlM.Text = "Ctrl+M";
			// 
			// labelCtrlP
			// 
			this.labelCtrlP.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelCtrlP.Location = new System.Drawing.Point(608, 72);
			this.labelCtrlP.Name = "labelCtrlP";
			this.labelCtrlP.Size = new System.Drawing.Size(40, 16);
			this.labelCtrlP.TabIndex = 65;
			this.labelCtrlP.Text = "Ctrl+P";
			// 
			// RunForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(664, 565);
			this.Controls.Add(this.labelCtrlP);
			this.Controls.Add(this.labelCtrlM);
			this.Controls.Add(this.labelCtrlF);
			this.Controls.Add(this.labelCtrlF5);
			this.Controls.Add(this.labelF5);
			this.Controls.Add(this.labelF4);
			this.Controls.Add(this.labelF3);
			this.Controls.Add(this.labelCtrlF7);
			this.Controls.Add(this.labelF7);
			this.Controls.Add(this.labelF8);
			this.Controls.Add(this.buttonReset);
			this.Controls.Add(this.labelEndTear);
			this.Controls.Add(this.labelStartYear);
			this.Controls.Add(this.labelYear);
			this.Controls.Add(this.textBoxEndYear);
			this.Controls.Add(this.textBoxStartYear);
			this.Controls.Add(this.textBoxYear);
			this.Controls.Add(this.buttonOByGFreq);
			this.Controls.Add(this.buttonOByJFreq);
			this.Controls.Add(this.buttonOByJDate);
			this.Controls.Add(this.buttonOByGDate);
			this.Controls.Add(this.buttonWFreq);
			this.Controls.Add(this.buttonWByDate);
			this.Controls.Add(this.buttonWOByYear);
			this.Controls.Add(this.buttonYearMinus);
			this.Controls.Add(this.buttonYearPlus);
			this.Controls.Add(this.buttonAbortCalc);
			this.Controls.Add(this.buttonClearLogFile);
			this.Controls.Add(this.buttonClearOutput);
			this.Controls.Add(this.buttonConfiguration);
			this.Controls.Add(this.buttonLog);
			this.Controls.Add(this.buttonPlot);
			this.Controls.Add(this.buttonQuit);
			this.Controls.Add(this.labelCtrlF9);
			this.Controls.Add(this.labelEsc);
			this.Controls.Add(this.labelF11);
			this.Controls.Add(this.labelF12);
			this.Controls.Add(this.labelF2);
			this.Controls.Add(this.labelF6);
			this.Controls.Add(this.labelF9);
			this.Controls.Add(this.labelRunning);
			this.Controls.Add(this.richTextOut);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenuRun;
			this.Name = "RunForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "<App.Title> - Run";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.memberFormClosing);
			this.Resize += new System.EventHandler(this.RunForm_Resize);
			this.ResumeLayout(false);
			this.PerformLayout();

		}
		#endregion

		public void Run(int iYear, int iStartYear, int iEndYear, StartupForm callerForm)
		// -------- Begin Main program Run for input and output to control calculations
		{
			if (Global.runFormUp) { Dispose(true); return; }
			Common.SetPriority(-1);		// lower priority to BelowNormal
			tQuitFlag = true;
			Global.runFormUp = true;
			Common.plotUp = false;
			Global.programURL = "http://www.geocities.com/hjsmithh/Easter/index.html";
			this.Show();
			this.Text = Global.title + " - Run";
			objStartupForm = callerForm;
			new Common();	// initialize class Common
			new EasterCS(iYear, iStartYear, iEndYear);	// initialize class EasterCS
			maxYear = StartupForm.maxYear;
			maxEndYear = StartupForm.maxEndYear;
			maxStartYear = StartupForm.maxStartYear;
			textBoxStartYear.Text = EasterCS.startYear.ToString();
			textBoxEndYear.Text = EasterCS.endYear.ToString();
			textBoxYear.Text = EasterCS.currYear.ToString();
			if (Common.homeDir == null) Common.homeDir = Environment.CurrentDirectory.ToString();
			if (Common.selectPath == null) Common.selectPath = Common.homeDir;
			if (Common.selectFile == null) Common.selectFile = "";
			if (Common.selectFilter == 0) Common.selectFilter = 1;
			Common.outS = Global.runTextOut;
			Common.runCmdLog = buttonLog;
			Global.runTextOut.Clear();
			ClearOutput();
			Common.DoubleSpace();
			EasterCS.DisplayOneYear(EasterCS.currYear);
			SetNotRunning();
			buttonPlot.Focus();
			if (Global.command != "")
			{
				string st = Global.command;
				Common.FixFName(ref st, "EaC");
				Common.codeFile = st;
				Common.Run();
				Global.command = "";
				Global.parmsDone = true;
			}
		} // Run

		public void SetRunning()
		{
			labelRunning.Text = "**Running**";
			Common.running = true;
		}

		public void SetNotRunning()
		{
			labelRunning.Text = "";
			Common.running = false;
		}

		public static void FocusBothUs() // focus on Run output text boxes
		{
			Global.runTextOut.Select(Global.runTextOut.Text.Length, 0); // move to bottom/end of output text box
			Global.runTextOut.Focus();
		}

		public static void ClearOutput() // clear Output Screen
		{
			DateTimePicker dateTime = new DateTimePicker();
			string dateTimeString = dateTime.Value.ToString();
			Common.DoubleSpace(); // double space for the possible benefit of the log file
			Global.runTextOut.Text = "";
			Common.WriteLn2("Output Screen: Cleared " + dateTimeString);
			Common.WriteLn(Global.runTextOut, null, Global.title + ", " + Global.version);
			if (Global.system != "") Common.WriteLn("Run on: " + Global.system);
			Common.WriteLn();
		}

		public static void HelpForm() // bring up the Help form
		{
			if (Global.helpUp < 3)			// allow at most 3 Help Forms up
			{
				HelpForm objHelpForm = new HelpForm();
				objHelpForm.Show();
				objHelpForm.Help();			// call sub Help in the Help Form
			}
		}

		private void buttonClearLogFile_Click(object sender, System.EventArgs e)
		// clear and initialize the log file
		{
			Common.ClearLog();
			SetLogCaption();
			FocusBothUs();
		}

		private void buttonClearOutput_Click(object sender, System.EventArgs e)
		// clear the output text box
		{
			ClearOutput();
		}

		private void buttonLog_Click(object sender, System.EventArgs e)
		// toggle the log screen to log file option
		{
			Common.ToggleLogg();
			FocusBothUs();
		}

		private void buttonQuit_Click(object sender, System.EventArgs e)
		// quit the Run form and go to Startup form
		{
			tQuitFlag = false;
			this.Close();		// memberFormClosing will do the work
			objStartupForm.SetValues(EasterCS.currYear, EasterCS.startYear, EasterCS.endYear);
		}

		private void buttonConfiguration_Click(object sender, System.EventArgs e)
		// bring up the configuration form
		{
			if (Common.configUp) return;
			ConfigForm objConfigForm = new ConfigForm();
			objConfigForm.Show();
			objConfigForm.Config();		// call sub Config in the Config Form
		}

		private void menuItemAbout_Click(object sender, System.EventArgs e)
		// bring up information about this program
		{
			try
			{
				AboutForm aboutForm = new AboutForm();
				aboutForm.ShowDialog();
				if (aboutForm.DialogResult == DialogResult.Cancel)
				{
					aboutForm.Dispose();
				}
			}
			catch (Exception ex)
			{
				System.Console.WriteLine(ex.Message.ToString());
			}
		}

		private void menuItemExit_Click(object sender, System.EventArgs e)
		// quit the Run form and go to Startup form
		{
			Exit();
		}

		public void Exit()
		// quit the Run form and go to Startup form
		{
			tQuitFlag = true;
			this.Close();		// memberFormClosing will do the work
		}

		private void menuItemHelpForm_Click(object sender, System.EventArgs e)
		// display the Help form
		{
			Common.DoubleSpace();
			HelpForm();
		}

		public void SetLogCaption() // set log command button Caption
		{
			if (Common.logg)
			{
				if (buttonLog.Text != "Logging Is On")
					buttonLog.Text  = "Logging Is On";
			}
			else
			{
				if (buttonLog.Text != "Logging Is Off")
					buttonLog.Text  = "Logging Is Off";
			}
		}

		private void timerRun_Tick(object sender, System.EventArgs e)
		// don't hog the processor, but don't slowdown too much
		{
			if (Common.running)
			{
				buttonPlot.Enabled = false;
			}
			else
			{
				buttonPlot.Enabled = true;
			}
			Application.DoEvents();	// process user requested actions;
		}

		private void FunctionKeys(object sender, KeyEventArgs e)
		// process requests from Function keys
		{
			if (e.KeyCode == Keys.F1)			// display the Help form
			{
				HelpForm();
			}
			else if (e.KeyCode == Keys.F2)		// quit program OR restart
			{
				tQuitFlag = false;
				this.Close();					// memberFormClosing will do the work
			}
			else if (e.KeyCode == Keys.F3)		// W O By Year
			{
				EasterCS.WOByYear();
			}
			else if (e.KeyCode == Keys.F4)		// W By Date
			{
				EasterCS.WByDate();
			}
			else if (e.KeyCode == Keys.F5)
			{
				if (Control.ModifierKeys != Keys.Control)
				{
					EasterCS.OByGDate();		// F5 O By G Date
				}
				else
				{
					EasterCS.OByJDate();		// Ctrl+F5 O By J Date
				}
			}
			else if (e.KeyCode == Keys.F6)		// display Configuration form
			{
				buttonConfiguration_Click(sender, e);
			}
			else if (e.KeyCode == Keys.F7)
			{
				if (Control.ModifierKeys != Keys.Control)
				{
					EasterCS.OByGFreq();		// F7 O By G Freq
				}
				else
				{
					EasterCS.OByJFreq();		// Ctrl+F7 O By J Freq
				}
			}
			else if (e.KeyCode == Keys.F8)		// Reset
			{
				buttonReset_Click(sender, e);
			}
			else if (e.KeyCode == Keys.F9)		// toggle Logging OR clear Log file
			{
				if(Control.ModifierKeys != Keys.Control)
				{
					buttonLog_Click(sender, e);	// F9 toggle Logging to Log file on/off
				}
				else
				{
					buttonClearLogFile_Click(sender, e);	// Ctrl+F9 clear Log file
				}
			}
			else if (e.KeyCode == Keys.F11)		// clear output TextBox
			{
				buttonClearOutput_Click(sender, e);
			}
			else if (e.KeyCode == Keys.F12)		// bring up the plot form
			{
				buttonPlot_Click(sender, e);
			}
			else if (e.KeyCode == Keys.F)
			{
				if (Control.ModifierKeys == Keys.Control)	// Ctrl+F W Frequency
				{
					EasterCS.WFreq();
				}
			}
			else if (e.KeyCode == Keys.M)
			{
				if (Control.ModifierKeys == Keys.Control)	// Ctrl+M Year-1
				{
					buttonYearMinus_Click(sender, e);
				}
			}
			else if (e.KeyCode == Keys.P)
			{
				if (Control.ModifierKeys == Keys.Control)	// Ctrl+P Year+1
				{
					buttonYearPlus_Click(sender, e);
				}
			}
			else if (e.KeyCode == Keys.Escape)	// interrupt/Abort a long calculation
			{
				buttonAbortCalc_Click(sender, e);
			}
		}

		private void RunForm_Resize(object sender, System.EventArgs e) // resize the run form
		{
			int jTop = buttonQuit.Top + buttonQuit.Height + 18;
			this.richTextOut.SetBounds(1, jTop, this.ClientRectangle.Width - 2, this.ClientRectangle.Height - jTop - 1);
		}

		private void memberFormClosing(object sender, System.ComponentModel.CancelEventArgs e)
		// the Run form is being closed so quit the Run form and go to Startup form
		// with .exe file, Close button click while running giver "Illegal operation"
		// so I put in a running test and a cancel
		{
			if (Common.running)
			{
				Common.abortCalc = true;
				Common.WriteDLn2("When **Running**, select Quit twice to quit");
				e.Cancel = true; // cancel the Unload request
				return;
			}
			if (Common.logg)
			{
				DateTimePicker dateTime = new DateTimePicker();
				string dateTimeString = dateTime.Value.ToString();
				Common.WriteLn("Log file " + Common.logFile + " Closed " + dateTimeString);
				Common.WriteLn(null, Common.outL);
				Common.outL.Close();
				Common.logg = false;
			}
			this.Hide();
			Global.runFormUp = false;
			if (tQuitFlag)
			{
				Dispose(true);
				objStartupForm.TotalQuit();
			}
			else
				objStartupForm.Show();
		}

		private void buttonPlot_Click(object sender, System.EventArgs e)
		// bring up the plot form
		{
			if (Common.running) return;
			if (Common.plotUp) return;
			PlotForm objPlotForm = new PlotForm();
			objPlotForm.Show();
			objPlotForm.Plot();		// call sub Plot in the Plot Form
		}

		public void AddToTitle(String st) // add st to form title
		{
			this.Text += st;
		}

		public void DelFromTitle(String st) // delete st from form title
		{
			this.Text = this.Text.Substring(0, this.Text.Length - st.Length);
		}
		
		public bool tQuitFlag;				// total quit/exit flag
		// tQuitFlag helps implement the requirement that a close or menuItemExit will totally quit the
		// program while a Quit will go to the Startup form
		private StartupForm objStartupForm;

		public static int helpHeight = 520;		// current height of the Help Form in pixels
		public static int helpWidth = 698;		// current width of the Help Form in pixels
		public static int runHeight = 622;		// current height of the Run Form in pixels
		public static int runWidth = 682;		// current width of the Run Form in pixels

		private static double NextDb(ref string st)
			// get next double from string
		{
			st = st.TrimStart(' ');		// delete leading blanks
			int p = st.IndexOf(' ');	// find next blank
			if (p < 0) p = st.Length;
			string s = st.Substring(0, p);
			st = st.Remove(0, p);
			try { return Convert.ToDouble(s); }
			catch { return 0.0; }
		}

		private void buttonAbortCalc_Click(object sender, System.EventArgs e)
		{
			if (Common.abortCalc) return;
			Common.abortCalc = true;
		}

		private void buttonYearPlus_Click(object sender, EventArgs e)
		{
			EasterCS.currYear++;
			EasterCS.FixCurrYear();
			textBoxYear.Text = EasterCS.currYear.ToString();
			EasterCS.DisplayOneYear(EasterCS.currYear);
		}

		private void buttonYearMinus_Click(object sender, EventArgs e)
		{
			EasterCS.currYear--;
			EasterCS.FixCurrYear();
			textBoxYear.Text = EasterCS.currYear.ToString();
			EasterCS.DisplayOneYear(EasterCS.currYear);
		}

		private void buttonWOByYear_Click(object sender, EventArgs e)
		// Dates of Western and Orthodox Easter, ordered by year, StartYear - EndYear
		{
			EasterCS.WOByYear();
		}

		private void buttonWByDate_Click(object sender, EventArgs e)
		// Dates of Western Easter, ordered by date, StartYear - EndYear 
		{
			EasterCS.WByDate();
		}

		private void buttonWFreq_Click(object sender, EventArgs e)
		// Frequency of Dates of Western Easter, StartYear - EndYear
		{
			EasterCS.WFreq();
		}

		private void buttonOByGDate_Click(object sender, EventArgs e)
		// Dates of Orthodox Easter, ordered by date, given in the Gregorian Calendar, StartYear - EndYear
		{
			EasterCS.OByGDate();
		}

		private void buttonOByJDate_Click(object sender, EventArgs e)
		// Dates of Orthodox Easter, ordered by date, given in the Julian Calendar, StartYear - EndYear
		{
			EasterCS.OByJDate();
		}

		private void buttonOByGFreq_Click(object sender, EventArgs e)
		{
			EasterCS.OByGFreq();
		}

		private void buttonOByJFreq_Click(object sender, EventArgs e)
		{
			EasterCS.OByJFreq();
		}

		private void textBoxYear_TextChanged(object sender, EventArgs e)
		// Year
		{
			string sNum = textBoxYear.Text.TrimStart(' ');		// remove leading spaces
			sNum = sNum.TrimStart('0');							// remove leading zeros
			if (sNum == "")
				sNum = "0";
			textBoxYear.Text = sNum;							// from text box
			if (Global.IsInt32(sNum))
			{
				int iNum = System.Convert.ToInt32(sNum);
				bYear = (1 <= iNum) && (iNum <= maxYear);
			}
			else
			{
				bYear = false;
			}
			int n = sNum.Length;
			if (n > 0 && sNum[n - 1] == ' ')	// remove space at end
			{
				sNum = sNum.TrimEnd(' ');
				textBoxYear.Text = sNum;
				textBoxYear.SelectionStart = sNum.Length;	// stay at end
			}
			SetFonts();
			if (bYear)
				EasterCS.currYear = System.Convert.ToInt32(textBoxYear.Text);
		}
		private void textBoxStartYear_TextChanged(object sender, EventArgs e)
		// Start Year
		{
			string sNum = textBoxStartYear.Text.TrimStart(' ');		// remove leading spaces
			sNum = sNum.TrimStart('0');								// remove leading zeros
			if (sNum == "")
				sNum = "0";
			textBoxStartYear.Text = sNum;							// from text box
			if (Global.IsInt32(sNum))
			{
				int iNum = System.Convert.ToInt32(sNum);
				bStartYear = (1 <= iNum) && (iNum <= maxStartYear);
			}
			else
			{
				bStartYear = false;
			}
			int n = sNum.Length;
			if (n > 0 && sNum[n - 1] == ' ')	// remove space at end
			{
				sNum = sNum.TrimEnd(' ');
				textBoxStartYear.Text = sNum;
				textBoxStartYear.SelectionStart = sNum.Length;	// stay at end
			}
			SetFonts();
			if (bStartYear)
				EasterCS.startYear = System.Convert.ToInt32(textBoxStartYear.Text);
		}
		private void textBoxEndYear_TextChanged(object sender, EventArgs e)
		// End Year
		{
			string sNum = textBoxEndYear.Text.TrimStart(' ');	// remove leading spaces
			sNum = sNum.TrimStart('0');							// remove leading zeros
			if (sNum == "")
				sNum = "0";
			textBoxEndYear.Text = sNum;							// from text box
			if (Global.IsInt32(sNum))
			{
				int iNum = System.Convert.ToInt32(sNum);
				bEndYear = (1 <= iNum) && (iNum <= maxEndYear);
			}
			else
			{
				bEndYear = false;
			}
			int n = sNum.Length;
			if (n > 0 && sNum[n - 1] == ' ')	// remove space at end
			{
				sNum = sNum.TrimEnd(' ');
				textBoxEndYear.Text = sNum;
				textBoxEndYear.SelectionStart = sNum.Length;	// stay at end
			}
			SetFonts();
			if (bEndYear)
				EasterCS.endYear = System.Convert.ToInt32(textBoxEndYear.Text);
		}

		private void SetFonts()
		{
			if (bYear)
				this.textBoxYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold);
			else
				this.textBoxYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular);
			if (bStartYear)
				this.textBoxStartYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold);
			else
				this.textBoxStartYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular);
			if (bEndYear)
				this.textBoxEndYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold);
			else
				this.textBoxEndYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular);
		}

		private void buttonReset_Click(object sender, EventArgs e)
		{
			Reset();
		}

		public void Reset()
		{
			textBoxStartYear.Text = EasterCS.startYear.ToString();
			textBoxEndYear.Text = EasterCS.endYear.ToString();
			textBoxYear.Text = EasterCS.currYear.ToString();
			EasterCS.DisplayOneYear(EasterCS.currYear);
		}

		private static int maxEndYear;		// Max EndYear allowed
		private static int maxStartYear;	// Max StartYear allowed
		private static int maxYear;			// Max Year allowed
		private static bool bEndYear;		// EndYear good flag
		private static bool bStartYear;		// StartYear good flag
		private static bool bYear;			// Year good flag
	}
}
