using System;
using System.Windows.Forms; // for Application

namespace MyNamespace
{
	/// <summary>
	///		Startup form for EasterCS program
	///		Developed in QuickBASIC 4.50, converted to Visual C# .Net
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation. cf. the file COPYING.txt.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>

	public class StartupForm : Form
	{
		private Button buttonDefault;
		private Button buttonExit;
		private Button buttonRun;
		private RichTextBox richTextIntro;
		private System.ComponentModel.IContainer components;
		private Label labelYear;
		private Label labelStartYear;
		private Label labelEndTear;
		private TextBox textBoxYear;
		private TextBox textBoxStartYear;
		private TextBox textBoxEndYear;
		private Timer timerStartup;

		public StartupForm()
		{
			InitializeComponent();
			maxYear = 10000000;			// [1, max]
			maxStartYear = 10000000;	// [1, max]
			maxEndYear = 10000000;		// [1, max]
			defaultYear = 2009;
			defaultStartYear = 1875;
			defaultEndYear = 2124;
			SetDefault();
			this.Text = Global.title + " - Startup";
			Pr("");
			Pr("   " + Global.name1);
			Pr("   " + Global.name2);
			Pr("   " + Global.version);
			Pr("   " + Global.author);
			Pr("   " + Global.address);
			Pr("");
			Pr("EasterCS is a program that computes when Easter comes in a given year:");
			Pr("");
			Pr("Easter Sunday is the Sunday following the Paschal Full Moon (PFM)");
			Pr("date for the year.");
			Pr("");
			Pr("Western Easter Sunday date is based on Scientific American, March 2001,");
			Pr("Mathematical Recreations by Ian Stewart, Page 82.");
			Pr("The period is 5,700,000 years.");
			Pr("Gregorian calendar started October 15, 1582 (previous day was Oct 4).");
			Pr("Germany switched to Gregorian calendar in 1700.");
			Pr("England and U.S. switched on Sept 14, 1752 (previous day was Sep 2).");
			Pr("Earliest Easter Sunday is on March 22 (in year 1818 and 2285 for example)");
			Pr("Latest Easter Sunday is on April 25 (in year 1943 and 2038 for example).");
			Pr("");
			Pr("The Date of Orthodox Easter:");
			Pr("This simple algorithm is listed in the Calendar FAQ by Claus Tondering.");
			Pr("It is based on Oudin's algorithm. E-mail: c-t@pip.dknet.dk.");
			Pr("");
			Pr("See:");
			Pr("http://www.assa.org.au/edm.html");
			Pr("http://www.smart.net/~mmontes/ortheast.html");
			Pr("http://www.tondering.dk/claus/calendar.html");
			Pr("http://www.geocities.com/hjsmithh/Easter/index.html");
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(StartupForm));
			this.richTextIntro = new System.Windows.Forms.RichTextBox();
			this.buttonRun = new System.Windows.Forms.Button();
			this.buttonExit = new System.Windows.Forms.Button();
			this.buttonDefault = new System.Windows.Forms.Button();
			this.timerStartup = new System.Windows.Forms.Timer(this.components);
			this.labelYear = new System.Windows.Forms.Label();
			this.labelStartYear = new System.Windows.Forms.Label();
			this.labelEndTear = new System.Windows.Forms.Label();
			this.textBoxYear = new System.Windows.Forms.TextBox();
			this.textBoxStartYear = new System.Windows.Forms.TextBox();
			this.textBoxEndYear = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// richTextIntro
			// 
			this.richTextIntro.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(208)))), ((int)(((byte)(244)))), ((int)(((byte)(255)))));
			this.richTextIntro.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.richTextIntro.ForeColor = System.Drawing.Color.Blue;
			this.richTextIntro.Location = new System.Drawing.Point(0, -8);
			this.richTextIntro.Name = "richTextIntro";
			this.richTextIntro.ReadOnly = true;
			this.richTextIntro.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.None;
			this.richTextIntro.Size = new System.Drawing.Size(516, 513);
			this.richTextIntro.TabIndex = 7;
			this.richTextIntro.Text = "";
			this.richTextIntro.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// buttonRun
			// 
			this.buttonRun.Cursor = System.Windows.Forms.Cursors.Arrow;
			this.buttonRun.Location = new System.Drawing.Point(536, 433);
			this.buttonRun.Name = "buttonRun";
			this.buttonRun.Size = new System.Drawing.Size(40, 24);
			this.buttonRun.TabIndex = 0;
			this.buttonRun.Text = "Run";
			this.buttonRun.Click += new System.EventHandler(this.buttonRun_Click);
			this.buttonRun.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// buttonExit
			// 
			this.buttonExit.Cursor = System.Windows.Forms.Cursors.Arrow;
			this.buttonExit.Location = new System.Drawing.Point(596, 433);
			this.buttonExit.Name = "buttonExit";
			this.buttonExit.Size = new System.Drawing.Size(40, 23);
			this.buttonExit.TabIndex = 1;
			this.buttonExit.Text = "Exit";
			this.buttonExit.Click += new System.EventHandler(this.buttonExit_Click);
			this.buttonExit.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// buttonDefault
			// 
			this.buttonDefault.Location = new System.Drawing.Point(532, 375);
			this.buttonDefault.Name = "buttonDefault";
			this.buttonDefault.Size = new System.Drawing.Size(104, 24);
			this.buttonDefault.TabIndex = 6;
			this.buttonDefault.Text = "Default Settings";
			this.buttonDefault.Click += new System.EventHandler(this.buttonDefault_Click);
			this.buttonDefault.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// timerStartup
			// 
			this.timerStartup.Enabled = true;
			this.timerStartup.Tick += new System.EventHandler(this.timerStartup_Tick);
			// 
			// labelYear
			// 
			this.labelYear.Location = new System.Drawing.Point(544, 112);
			this.labelYear.Name = "labelYear";
			this.labelYear.Size = new System.Drawing.Size(53, 16);
			this.labelYear.TabIndex = 16;
			this.labelYear.Text = "Year";
			// 
			// labelStartYear
			// 
			this.labelStartYear.Location = new System.Drawing.Point(542, 188);
			this.labelStartYear.Name = "labelStartYear";
			this.labelStartYear.Size = new System.Drawing.Size(55, 16);
			this.labelStartYear.TabIndex = 17;
			this.labelStartYear.Text = "Start Year";
			// 
			// labelEndTear
			// 
			this.labelEndTear.Location = new System.Drawing.Point(544, 271);
			this.labelEndTear.Name = "labelEndTear";
			this.labelEndTear.Size = new System.Drawing.Size(55, 16);
			this.labelEndTear.TabIndex = 18;
			this.labelEndTear.Text = "End Year";
			// 
			// textBoxYear
			// 
			this.textBoxYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.textBoxYear.Location = new System.Drawing.Point(538, 131);
			this.textBoxYear.Name = "textBoxYear";
			this.textBoxYear.Size = new System.Drawing.Size(72, 20);
			this.textBoxYear.TabIndex = 19;
			this.textBoxYear.Text = "10000000";
			this.textBoxYear.TextChanged += new System.EventHandler(this.textBoxYear_TextChanged);
			this.textBoxYear.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// textBoxStartYear
			// 
			this.textBoxStartYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.textBoxStartYear.Location = new System.Drawing.Point(538, 207);
			this.textBoxStartYear.Name = "textBoxStartYear";
			this.textBoxStartYear.Size = new System.Drawing.Size(72, 20);
			this.textBoxStartYear.TabIndex = 20;
			this.textBoxStartYear.Text = "10000000";
			this.textBoxStartYear.TextChanged += new System.EventHandler(this.textBoxStartYear_TextChanged);
			this.textBoxStartYear.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// textBoxEndYear
			// 
			this.textBoxEndYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.textBoxEndYear.Location = new System.Drawing.Point(536, 290);
			this.textBoxEndYear.Name = "textBoxEndYear";
			this.textBoxEndYear.Size = new System.Drawing.Size(72, 20);
			this.textBoxEndYear.TabIndex = 21;
			this.textBoxEndYear.Text = "10000000";
			this.textBoxEndYear.TextChanged += new System.EventHandler(this.textBoxEndYear_TextChanged);
			this.textBoxEndYear.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			// 
			// StartupForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Control;
			this.ClientSize = new System.Drawing.Size(648, 504);
			this.Controls.Add(this.textBoxEndYear);
			this.Controls.Add(this.textBoxStartYear);
			this.Controls.Add(this.textBoxYear);
			this.Controls.Add(this.labelEndTear);
			this.Controls.Add(this.labelStartYear);
			this.Controls.Add(this.labelYear);
			this.Controls.Add(this.buttonDefault);
			this.Controls.Add(this.buttonExit);
			this.Controls.Add(this.buttonRun);
			this.Controls.Add(this.richTextIntro);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "StartupForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "<App.Title> - Startup";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.memberFormClosing);
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.buttonRun_KeyDown);
			this.ResumeLayout(false);
			this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args) // get command line arguments and bring up the frame
		{
			new Global();	// initialize class Global
			if (args.Length > 0) Global.command = args[0];
			Global.parmsDone = Global.command == "";
			StartupForm objStartupForm = new StartupForm();
			startupTicks = 1;
			if (!objStartupForm.IsDisposed) Application.Run(objStartupForm);
		}

		private void Pr(string st)
		{
			richTextIntro.Text += "   " + st + "\n";
		}

		private void textBoxYear_TextChanged(object sender, EventArgs e)
		// Year
		{
			string sNum = textBoxYear.Text.TrimStart(' ');	// remove leading spaces
			sNum = sNum.TrimStart('0');						// remove leading zeros
			if (sNum == "")
				sNum = "0";
			textBoxYear.Text = sNum;						// from text box
			if (Global.IsInt32(sNum))
			{
				int iNum = System.Convert.ToInt32(sNum);
				bYear = (1 <= iNum) && (iNum <= maxYear);
			}
			else
			{
				bYear = false;
			}
			int n = sNum.Length;
			if (n > 0 && sNum[n - 1] == ' ') // remove space at end
			{
				sNum = sNum.TrimEnd(' ');
				textBoxYear.Text = sNum;
				textBoxYear.SelectionStart = sNum.Length; // stay at end
			}
			SetFonts();
		}

		private void textBoxStartYear_TextChanged(object sender, EventArgs e)
		// Start Year
		{
			string sNum = textBoxStartYear.Text.TrimStart(' ');	// remove leading spaces
			sNum = sNum.TrimStart('0');						// remove leading zeros
			if (sNum == "")
				sNum = "0";
			textBoxStartYear.Text = sNum;						// from text box
			if (Global.IsInt32(sNum))
			{
				int iNum = System.Convert.ToInt32(sNum);
				bStartYear = (1 <= iNum) && (iNum <= maxStartYear);
			}
			else
			{
				bStartYear = false;
			}
			int n = sNum.Length;
			if (n > 0 && sNum[n - 1] == ' ') // remove space at end
			{
				sNum = sNum.TrimEnd(' ');
				textBoxStartYear.Text = sNum;
				textBoxStartYear.SelectionStart = sNum.Length; // stay at end
			}
			SetFonts();
		}

		private void textBoxEndYear_TextChanged(object sender, EventArgs e)
		// End Year
		{
			string sNum = textBoxEndYear.Text.TrimStart(' ');	// remove leading spaces
			sNum = sNum.TrimStart('0');						// remove leading zeros
			if (sNum == "")
				sNum = "0";
			textBoxEndYear.Text = sNum;						// from text box
			if (Global.IsInt32(sNum))
			{
				int iNum = System.Convert.ToInt32(sNum);
				bEndYear = (1 <= iNum) && (iNum <= maxEndYear);
			}
			else
			{
				bEndYear = false;
			}
			int n = sNum.Length;
			if (n > 0 && sNum[n - 1] == ' ') // remove space at end
			{
				sNum = sNum.TrimEnd(' ');
				textBoxEndYear.Text = sNum;
				textBoxEndYear.SelectionStart = sNum.Length; // stay at end
			}
			SetFonts();
		}

		private void buttonDefault_Click(object sender, System.EventArgs e)
		{
			SetDefault();
		}

		private void SetDefault()
		{
			textBoxYear.Text = defaultYear.ToString();
			textBoxStartYear.Text = defaultStartYear.ToString();
			textBoxEndYear.Text = defaultEndYear.ToString();
			bYear = bStartYear = bEndYear = buttonRun.Enabled = true;
			SetFonts();
		}

		private void buttonRun_Click(object sender, System.EventArgs e)
		// start running the program
		{
			buttonRunProg();
		}

		private void buttonRunProg() // start running the program
		{
			int iYear = System.Convert.ToInt32(textBoxYear.Text);
			int iStartYear = System.Convert.ToInt32(textBoxStartYear.Text);
			int iEndYear = System.Convert.ToInt32(textBoxEndYear.Text);
			this.Hide();
			Global.objRunForm = new RunForm();
			Global.objRunForm.Show();
			Global.objRunForm.Run(iYear, iStartYear, iEndYear, this); // call sub Run in the form frmRun
		}

		private void SetFonts()
		{
			if (bYear)
				this.textBoxYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold);
			else
				this.textBoxYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular);
			if (bStartYear)
				this.textBoxStartYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold);
			else
				this.textBoxStartYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular);
			if (bEndYear)
				this.textBoxEndYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold);
			else
				this.textBoxEndYear.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular);
			buttonRun.Enabled = bYear && bStartYear && bEndYear;
		}

		public void TotalQuit()
		{
			Dispose(true);
		}

		private void buttonExit_Click(object sender, System.EventArgs e)
		{
			Dispose(true);
		}

		private void buttonRun_KeyDown(object sender, KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Escape)		// ESC key pressed so Exit Startup
			{
				Dispose(true);
			}
		}

		private void timerStartup_Tick(object sender, System.EventArgs e)
		{
			if (startupTicks > 0) startupTicks++;
			if (startupTicks > 100)
				timerStartup.Enabled = false;	// and then only needed once
			if (!Global.parmsDone)
			{
				timerStartup.Enabled = false;
				buttonRunProg();
			}
		}

		private void memberFormClosing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			Dispose(true);
		}

		public void SetValues(int currYear, int startYear, int endYear)
		{
			textBoxYear.Text = currYear.ToString();
			textBoxStartYear.Text = startYear.ToString();
			textBoxEndYear.Text = endYear.ToString();			
		}

		private static bool bEndYear;			// EndYear good flag
		private static bool bStartYear;			// StartYear good flag
		private static bool bYear;				// Year good flag
		private static int defaultEndYear;		// EndYear default
		private static int defaultStartYear;	// StartYear default
		private static int defaultYear;			// Year default
		public static int maxEndYear;			// Max EndYear allowed
		public static int maxStartYear;			// Max StartYear allowed
		public static int maxYear;				// Max Year allowed
		private static int startupTicks = 0;
	}
}
